//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DBDlgSearch.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TDBDlgSearch *DBDlgSearch;
//---------------------------------------------------------------------
__fastcall TDBDlgSearch::TDBDlgSearch(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------
void __fastcall TDBDlgSearch::setDataSet(TDataSet *set)
{
  TField *f;

  if (set != FDataSet) {

     cbFields->Items->Clear();
     edValue->Text = "";

     for (int i = 0; i < set->FieldCount; i++) {
         f = set->Fields->Fields[i];

         if (f->FieldKind == fkData && ftMemo!=f->DataType )
            cbFields->Items->AddObject(f->DisplayLabel, set->Fields->Fields[i]);
     }

     cbFields->ItemIndex = 0;
     FDataSet = set;
  }
}
//---------------------------------------------------------------------
// LOCATE (loCaseInsensitive muy ineficiente en C/S)

// Con BDE usar una consulta preparada (TQuery):
//
// 1. select ...
//    from tabla
//    where upper(campo) starting with :param
//
// 2. select ...
//    from table
//    where upper(campo)>:param
//    order by campo

bool __fastcall TDBDlgSearch::run(TDataSet *ADataSet)
{
  bool           Rslt = False;
  TField        *field;
  TLocateOptions SearchOptions;

  SearchOptions = SearchOptions<<loPartialKey<<loCaseInsensitive;

  DataSet = ADataSet;

  if (ShowModal() == mrOk) {
     field = (TField*)(cbFields->Items->Objects[cbFields->ItemIndex]);
     Rslt  = FDataSet->Locate(field->FieldName,edValue->Text,SearchOptions);

     if (! Rslt)
        Application->MessageBox("Valor no encontrado","Error", MB_OK | MB_ICONSTOP);
  }

  return Rslt;
}

//---------------------------------------------------------------------
// FILTROS
//---------------------------------------------------------------------

// Normalizacin de una cadena: Eliminacin de tildes...

void __fastcall TDBDlgSearch::normalize (String *str)
{
  int dim = str->Length();
  int i;

  for (i=1; i<=dim; i++)
      switch ((*str)[i]) {

        case '': case '': case '': case '':
        case '': case '': case '': case '':
             (*str)[i] = 'A';
             break;

        case '': case '': case '': case '':
        case '': case '': case '': case '':
             (*str)[i] = 'E';
             break;

        case '': case '': case '': case '':
        case '': case '': case '': case '':
             (*str)[i] = 'I';
             break;

        case '': case '': case '': case '':
        case '': case '': case '': case '':
             (*str)[i] = 'O';
             break;

        case '': case '': case '': case '':
        case '': case '': case '': case '':
             (*str)[i] = 'U';
             break;

        case '':
             (*str)[i] = '';
             break;
      }
}

// Evento OnFilterRecord

void __fastcall TDBDlgSearch::FilterRecord(TDataSet *DataSet, bool &Accept)
{
  int    field  = cbFields->ItemIndex;
  String value  = UpperCase(DataSet->Fields->Fields[field]->AsString);

  normalize(&value);

  Accept = (value.Pos(search)>0);
}

// Bsqueda con filtros (no permitida en campos MEMO)

bool __fastcall TDBDlgSearch::find(TDataSet *ADataSet)
{
  bool Rslt = False;

  DataSet = ADataSet;

  if (ShowModal() == mrOk) {

     // 1. Propiedad Filter
     // -------------------

     // TField *field;
     // field = (TField*)(cbFields->Items->Objects[cbFields->ItemIndex]);
     // DataSet->Filter = Format("[%s] = %s", ARRAYOFCONST((field->FieldName, QuotedStr(edValue->Text+"*"))));

     // 2. Evento OnFilterRecord
     // ------------------------

     search = UpperCase(edValue->Text);
     normalize(&search);
     DataSet->OnFilterRecord = FilterRecord;

     // ---

     Rslt = DataSet->FindFirst();

     if (!Rslt)
        Application->MessageBox("Valor no encontrado", "Error", MB_ICONERROR | MB_OK);
  }

  return Rslt;
}


bool __fastcall TDBDlgSearch::findNext()
{
  if (!DataSet->FindNext()) {
     // Application->MessageBox("Valor no encontrado", "Error", MB_ICONERROR | MB_OK);
     return False;
  } else
     return True;
}

bool __fastcall TDBDlgSearch::findPrior()
{
  if (!DataSet->FindPrior()) {
     // Application->MessageBox("Valor no encontrado", "Error", MB_ICONERROR | MB_OK);
     return False;
  } else
     return True;
}

bool __fastcall TDBDlgSearch::findFirst()
{
  if (!DataSet->FindFirst()) {
     Application->MessageBox("Valor no encontrado", "Error", MB_ICONERROR | MB_OK);
     return False;
  } else
     return True;
}

bool __fastcall TDBDlgSearch::findLast()
{
  if (!DataSet->FindLast()) {
     Application->MessageBox("Valor no encontrado", "Error", MB_ICONERROR | MB_OK);
     return False;
  } else
     return True;
}

